/*
 * SPObject.java
 *
 * AvJX^pl XNb`pbhANZXC^[tF[X
 *
 * Copyright ITmarks Inc. All rights reserved.
 */
package iappli.lib.io;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
 * XNb`pbhւ̃ANZX`C^[tF[XłB<br>
 * f[^̕ۑKvȃNXɎ邱ƂɂA
 * ̃NX̕ێf[^ۑA邱Ƃł܂B<br><br>
 * 
 * {NXIuWFNg SPControl ɓnƂŁA
 * XNb`pbhɃANZX܂BXNb`pbh𗘗pɂ́A
 * `ce SPSize ɁAۑɕKvȃf[^TCYw肵ĂB<br>
 * 
 * <pre>
 * yz
 * public class Test extends IApplication {
 *   public void start() {
 *     Sample s1 = new Sample(100);
 *     Sample s2 = new Sample(200);
 *     try {
 *       // s1  s2 ̃f[^ۑ
 *       int pos = 0;
 *       pos = SPControl.write(s1, pos);
 *       pos = SPControl.write(s2, pos);
 *     } catch (IOException e) { }
 * 
 *     Sample s3 = new Sample(0);
 *     Sample s4 = new Sample(0);
 *     try {
 *       // s1  s2 ̃f[^ s3  s4 ɕ
 *       int pos = 0;
 *       pos = SPControl.read(s3, pos);
 *       pos = SPControl.read(s4, pos);
 *     } catch (IOException e) { }
 *   }
 * }
 * 
 * class Sample implements SPObject {
 *   public Sample(int a) {
 *     this.a = a;
 *   }
 * 
 *   // *** SampleŎgf[^𕜌
 *   public int readObject(DataInputStream in) throws IOException {
 *     a = in.readInt();
 *     return 4;
 *   }
 *
 *   // *** SampleŎgf[^ۑ
 *   public int writeObject(DataOutputStream out) throws IOException {
 *     out.writeInt(a);
 *     return 4;
 *   }
 *   private int a = 0;
 * }
 * </pre>
 */
public interface SPObject {

    /**
     * XNb`pbhփf[^ۑ܂B<br>
     * DataOutputStreamŏłB<br>
     * ݊A񂾃f[^̍vTCYԂĂB<br>
     * 
     * ރf[^͓ǂݍރf[^ƓŎw肵܂B<br>
     *
     * <pre>
     * yz
     * public int writeObject(DataOutputStream out) throws IOException {
     *   int  a = 100;
     *   byte b = 200;
     *   out.writeInt(a);        // a (int)  4byte
     *   out.write(200);         // b (byte) 1byte
     *   return 5;               // 񂾃f[^̍vTCYԂB
     * }
     * 
     * public int readObject(DataInputStream in) throws IOException {
     *   int  a = in.readInt();  // a (int) ǂݍ
     *   byte b = in.read();     // b (byte)ǂݍ
     *   return 5;               // ǂݍ񂾃f[^̍vTCYԂB
     * }
     * </pre>
     * 
     * @param out XNb`pbhւ̃f[^o̓Xg[n܂B
     * @return 񂾃oCgԂ܂B
     *          {@link SPControl#write(SPObject, int, int)} ŁA
     *          Ԃ߂l(݈ʒu̍Ō)ɉZ܂B
     *          Javå{^̃TCYɂӂB
     * @throws IOException DataOutputStream̗OłB
     */
    public int writeObject(DataOutputStream out) throws IOException ;

    /**
     * XNb`pbhf[^擾܂B<br>
     * DataInputStreamœǂݍłB<br><br>
     * ǂݍ݊Aǂݍ񂾃f[^̍vTCYԂĂB<br>
     * 
     * ǂݍރf[^͏ރf[^ƓŎw肵܂B<br>
     *
     * <pre>
     * yz
     * public int writeObject(DataOutputStream out) throws IOException {
     *   int  a = 100;
     *   byte b = 200;
     *   out.writeInt(a);        // a (int)  4byte
     *   out.write(200);         // b (byte) 1byte
     *   return 5;               // 񂾃f[^̍vTCYԂB
     * }
     * 
     * public int readObject(DataInputStream in) throws IOException {
     *   int  a = in.readInt();  // a (int) ǂݍ
     *   byte b = in.read();     // b (byte)ǂݍ
     *   return 5;               // ǂݍ񂾃f[^̍vTCYԂB
     * }
     * </pre>
     * 
     * @param in XNb`pbh̃f[^̓Xg[n܂B
     * @return 񂾃oCgԂ܂B
     *          {@link SPControl#write(SPObject, int, int)} ŁA
     *          Ԃ߂l(݈ʒu̍Ō)ɉZ܂B
     *          Javå{^̃TCYɂӂB
     * @throws IOException DataInputStream̗OłB
     */
    public int readObject(DataInputStream in) throws IOException ;

}
